
clc
clear all
close all
format short

choice = 'k';

% LOAD data from Fortran
if (1>0)
    M = dlmread('results.dat','',0,0);
    N = size(M,1)/2;

    for i=1:N
        x(i,1)=M(1+2*(i-1),1);
        y(i,1)=M(1+2*(i-1),2);
        u(i,1)=M(1+2*(i-1),3);
        v(i,1)=M(1+2*(i-1)+1,1);
        P(i,1)=M(1+2*(i-1)+1,2);
        vort(i,1)=M(1+2*(i-1)+1,3);
    end

    n=sqrt(N);
    x = reshape(x,n,n)';
    y = reshape(y,n,n)';
    u = reshape(u,n,n)';
    v = reshape(v,n,n)';
    P = reshape(P,n,n)';
    vort = reshape(vort,n,n)';
    
%    save results-MB-LWACM-RE10000-256x256.mat
else
%    load results-MB-BGK-RE10000-128x128.mat
end

for i=1:(n*3)
    for j=1:(n*3)
        quadi = ceil(i/n)-1;
        quadj = ceil(j/n)-1;
        xL(i,j) = x(i-quadi*n,j-quadj*n)+quadj;
        yL(i,j) = y(i-quadi*n,j-quadj*n)+quadi;
        uL(i,j) = u(i-quadi*n,j-quadj*n);
        vL(i,j) = v(i-quadi*n,j-quadj*n);
    end
end

[omegaL]=vorticity(xL,yL,uL,vL,'centered'); % Matlab CURL
%[omegaL]=vorticity(xL,yL,uL,vL,'richardson');
%[omegaL]=vorticity(xL,yL,uL,vL,'leastsq');
%[omegaL]=vorticity(xL,yL,uL,vL,'circulation');

[divL] = divergence(xL,yL,uL,vL);

for i=(n+1):(n*2)
    for j=(n+1):(n*2)
        quadi = ceil(i/n)-1;
        quadj = ceil(j/n)-1;
        omega(i-quadi*n,j-quadj*n)=omegaL(i,j);
        div(i-quadi*n,j-quadj*n)=divL(i,j);
    end
end

% FIGURE 2
fh2 = figure(2);
pointer = streamslice(x,y,u,v,1,'-k'); grid on, hold on
for i=1:size(pointer,1)
    set(pointer(i),'Color',choice)
end
axis([0 1 0 1])
set(fh2,'Position',[22 43 694 655])
hy2=ylabel('y [-]');
hx2=xlabel('x [-]');
set(hy2,'FontSize',18)
set(hx2,'FontSize',18)
ax2 = gca;
set(ax2,'XColor','k','YColor','k',...
           'FontSize',18,...
           'LineWidth',1);

% FIGURE 3
fh3 = figure(3);
mesh(x,y,omega); grid on, hold on
axis([0 1 0 1])
set(fh3,'Position',[22 43 694 655])
hy3=ylabel('y [-]');
hx3=xlabel('x [-]');
set(hy3,'FontSize',18)
set(hx3,'FontSize',18)
ax3 = gca;
set(ax3,'XColor','k','YColor','k',...
           'FontSize',18,...
           'LineWidth',1);

% FIGURE 1
fh1 = figure(1);
[c,h] = contourf(x,y,omega,[-60:2:-5,5:2:60]);hold on
axis([0 1 0 1])
set(fh1,'Position',[22 43 694 655])
hy1=ylabel('y [-]');
hx1=xlabel('x [-]');
set(hy1,'FontSize',18)
set(hx1,'FontSize',18)
ax1 = gca;
set(ax1,'XColor','k','YColor','k',...
           'FontSize',18,...
           'LineWidth',1);

% FIGURE 4
fh3 = figure(4);
mesh(x,y,div); grid on, hold on
axis([0 1 0 1])
set(fh3,'Position',[22 43 694 655])
hy3=ylabel('y [-]');
hx3=xlabel('x [-]');
set(hy3,'FontSize',18)
set(hx3,'FontSize',18)
ax3 = gca;
set(ax3,'XColor','k','YColor','k',...
           'FontSize',18,...
           'LineWidth',1);

AA = mean(mean(abs(div)))
MM = max(max(abs(div)))

% FIGURE 5
fh1 = figure(5);
[c,h] = contourf(x,y,vort,[-60:2:-5,5:2:60]);hold on
axis([0 1 0 1])
set(fh1,'Position',[22 43 694 655])
hy1=ylabel('y [-]');
hx1=xlabel('x [-]');
set(hy1,'FontSize',18)
set(hx1,'FontSize',18)
ax1 = gca;
set(ax1,'XColor','k','YColor','k',...
           'FontSize',18,...
           'LineWidth',1);
